varying vec3 f_normal;

#ifdef VERTEX
	attribute vec3 VertexNormal;
	attribute vec4 VertexWeight;
	attribute vec4 VertexBone; // NOTE: Actually used as int...

	uniform mat4 u_view, u_model, u_projection; // TODO: (ab)use love's built in matrices instead?
	uniform mat4 u_bone_matrices[200]; // this is why I want UBOs...
	uniform int	 u_skinning = 0;

	mat4 getDeformMatrix() {
		if (u_skinning != 0) {
			return u_bone_matrices[int(VertexBone.x)] * VertexWeight.x +
				u_bone_matrices[int(VertexBone.y)] * VertexWeight.y +
				u_bone_matrices[int(VertexBone.z)] * VertexWeight.z +
				u_bone_matrices[int(VertexBone.w)] * VertexWeight.w;
		}
		return mat4(1.0);
	}

	vec4 position(mat4 mvp, vec4 v_position) {
		// f_normal = VertexNormal;
		// f_up_normal = (u_view * vec4(vec3(0.0, 0.0, 1.0), 1.0)).xyz;
		f_normal = (u_model * vec4(VertexNormal, 1.0)).xyz;
		return u_projection * u_view * u_model * getDeformMatrix() * v_position;
	}
#endif

#ifdef PIXEL
	uniform vec3 ambient = vec3(0.0);
	uniform int use_color = 0;
	uniform int use_fresnel = 0;
	const vec4 refl = vec4(1.0, 1.0, 1.0, 1.0);

	vec4 effect(vec4 color, Image texture, vec2 texture_coords, vec2 screen_coords) {
		if (use_color == 0)
			color = vec4(1.0);

		vec3 tex = texture2D(texture, texture_coords).rgb;

		if (use_fresnel == 1) {
			float shade = pow(clamp(dot(f_normal, vec3(0.0, 0.0, 1.0)), 0.0001, 1.0), 0.9) * 0.1;
			float fresnel = pow(clamp(dot(f_normal, vec3(0.0, 1.0, 0.0)), 0.0001, 1.0), 2.05);
			float factor = clamp(fresnel + 0.9 - shade, 0.0, 1.0);
			return mix(refl, vec4(tex + ambient, 1.0), factor) * color;
		}
		return vec4(tex + ambient, 1.0) * color;
	}
#endif
